<!DOCTYPE html>
<meta charset="utf-8">

<!-- <div id='status'>Data status</div> -->
<head>
<link rel="stylesheet" type="text/css" href="/static/css/sw_viewer.css"/>
<script src="/static/js/d3.min.js"></script>
<script src="/static/js/zoom.js"></script>
<script src="/static/js/subplot.js"></script>
<script src="/static/js/kp.js"></script>
<!--<script src="/static/js/imf.js"></script>-->
<script src="/static/js/sw.js"></script>
<script src="/static/js/sdomovie.js"></script>
<script src="/static/js/timeseries.js"></script>
</head>
<body>
  <div id="videocontainer"></div><div id="chartcontainer"></div>
</body>
<script>
  var subplots = [];
  var plotelements = [];

  var now = new Date();//2015,5,25,0,0,0);
  var tmin = d3.utcDay.offset(now, -6);
  var tmax = d3.utcDay.offset(now, 3);

  var globalx = {
    margins: {left: 40, right: 40},
    get width() {
      return document.getElementById("chartcontainer").clientWidth - this.margins.left - this.margins.right
    },
  };
  globalx.xtransform = d3.scaleUtc().range([0, globalx.width]).domain([tmin, tmax]);
  globalx.xtransform_z = d3.scaleUtc().range([0, globalx.width]).domain([tmin, tmax]);

  var innerHeight = window.innerHeight;  

   subplot_kp = new subplot_generator("chartcontainer")
     .title("Kp index")
     .id("kp")
     .ymin(0)
     .ymax(9)
     .ytickformat(d3.format("1d"))
     .height(0.1*innerHeight - 10)
     .margins({top: 5, bottom: 5})    
     .xaxisannotation("hidden")
     .draw()
     .updateDateTimeAxis();

   plotelement_kp_forecast = new plot_element_kp("kp_index_forecast_noaa", "kp_index")
     .subplot(subplot_kp)
     .barpadding(0)
     .showkptext(false)
     .datatype("forecast");
   plotelement_kp_forecast
     .loadData();

   plotelement_kp = new plot_element_kp("kp_index", "kp_index")
     .subplot(subplot_kp)
     .showkptext(true);
   plotelement_kp
     .loadData();

  subplot_imf = new subplot_generator("chartcontainer")
    .title("Interplanetary Magnetic Field Bt and Bz (nT)")
    .id("imf")
    .ymin(-30)
    .ymax(30) 
    .ytickformat(d3.format("d"))
    .ydynamic(false)
    .margins({top: 5, bottom: 5})    
    .xaxisannotation("hidden")    
    .height(0.18*innerHeight-10)
    .draw()
    .updateDateTimeAxis();

 plotelement_imf_rt_bt = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_mag_rt')
    .parameters('bt')
    .subplot(subplot_imf)
    .stroke('none')
    .fill('#d0d0d0')
    .fill_opacity("50%")
    .mirror_area(true);
  plotelement_imf_rt_bt
    .loadData();

  plotelement_imf_rt_bz = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_mag_rt')
    .parameters('bz_gsm')
    .subplot(subplot_imf)
    .stroke('none')
    .fill('#f06060');
  plotelement_imf_rt_bz
    .loadData();

  plotelement_imf_ace_bt = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_mag_ace')
    .parameters('bt')
    .subplot(subplot_imf)
    .stroke('none')
    .fill('#d0d0d0')
    .fill_opacity("50%")
    .mirror_area(true);
  plotelement_imf_ace_bt
    .loadData();

  plotelement_imf_ace_bz = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_mag_ace')
    .parameters('bz_gsm')
    .subplot(subplot_imf)
    .stroke('none')
    .fill('#f06060');
  plotelement_imf_ace_bz
    .loadData();

  plotelement_imf_dscovr_bt = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_mag_dscovr')
    .parameters('bt')
    .subplot(subplot_imf)
    .stroke('none')
    .fill('#d0d0d0')
    .fill_opacity("50%")
    .mirror_area(true);
  plotelement_imf_dscovr_bt
    .loadData();

  plotelement_imf_dscovr_bz = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_mag_dscovr')
    .parameters('bz_gsm')
    .subplot(subplot_imf)
    .stroke('none')
    .fill('#f06060');
  plotelement_imf_dscovr_bz
    .loadData();

 subplot_swspeed = new subplot_generator("chartcontainer")
    .title("Solar wind speed (km/s)")
    .id("swspeed")
    .ymin(200)
    .ymax(1200)
    .ytickformat(d3.format("d"))
    .ydynamic(false)
    .margins({top: 5, bottom: 5})            
    .xaxisannotation("hidden")    
    .height(0.18*innerHeight-10)
    .draw()
    .updateDateTimeAxis();

  plotelement_swspeed_rt = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_plasma_rt')
    .parameters('speed')
    .subplot(subplot_swspeed)
    .fill('lightyellow')
    .stroke('orange');
  plotelement_swspeed_rt
    .loadData();
  
  plotelement_swspeed_ace = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_plasma_ace')
    .parameters('speed')
    .subplot(subplot_swspeed)
    .fill('none')
    .stroke('red');
  plotelement_swspeed_ace
    .loadData();    

  plotelement_swspeed_dscovr = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_plasma_dscovr')
    .parameters('speed')
    .subplot(subplot_swspeed)
    .fill('none')
    .stroke('orange');
  plotelement_swspeed_dscovr
    .loadData();    

  subplot_swdensity = new subplot_generator("chartcontainer")
    .title("Solar wind density (1/cm³)")
    .id("swdens")
    .ytransform(d3.scaleLog().range([10, 0]).domain([1e-1,1e3]))
    .ytickformat(d3.format(".1r"))
    .ymin(1e-1)
    .ymax(1e3)
    .ydynamic(false)
    .xaxisannotation("hidden")
    .margins({top: 5, bottom: 5})        
    .height(0.18*innerHeight-10)
    .draw()
    .updateDateTimeAxis();
  
  plotelement_swdensity_rt = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_plasma_rt')
    .parameters('density')
    .subplot(subplot_swdensity)
    .stroke("darkblue")
    .fill("#E0F0FF");
  plotelement_swdensity_rt
    .loadData();

  plotelement_swdensity_dscovr = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_plasma_dscovr')
    .parameters('density')
    .subplot(subplot_swdensity)
    .stroke("blue")
    .fill("none");
  plotelement_swdensity_dscovr
    .loadData();

  plotelement_swdensity_ace = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('solar_wind_plasma_ace')
    .parameters('density')
    .subplot(subplot_swdensity)
    .stroke("lightblue")
    .fill("none");
  plotelement_swdensity_ace
    .loadData();

  subplot_xrayflux = new subplot_generator("chartcontainer")
    .title("X-ray flux (W/m²)")
    .id("swdens")
    .ytransform(d3.scaleLog().range([10, 0]).domain([1e-9,1e-2]))
    .ytickformat(d3.format("1.0e"))
    .ymin(1e-9)
    .ymax(1e-2)
    .ydynamic(false)
    .xaxisannotation("visible")
    .margins({top: 5, bottom: 30})        
    .height(0.18*innerHeight-10)
    .draw()
    .updateDateTimeAxis();
  
  plotelement_xrayflux = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('xray_flux_rt')
    .parameters('xray_flux_long')
    .subplot(subplot_xrayflux)
    .stroke("red")
    .fill("pink");
  plotelement_xrayflux
    .loadData();

  plotelement_xrayflux_goes16 = new plot_element_timeseries()
    .server('/hapi-r')
    .dataset('xray_flux_goes16')
    .parameters('xray_flux_long')
    .subplot(subplot_xrayflux)
    .stroke("red")
    .fill("none");
  plotelement_xrayflux_goes16
    .loadData();

/*
  plotelement_xrayflux_goes15 = new plot_element_timeseries("xray_flux_goes15", "xray_flux_long")
    .subplot(subplot_xrayflux)
    .stroke("darkgoldenrod")
    .fill("none");
  plotelement_xrayflux_goes15
    .loadData();
*/

/*
  sp = new subplot_generator("chartcontainer")
    .title("SDO daily movies")
    .id("sdo_daily_movies")
    .zoomable(false)
    .xaxisannotation("visible")
    .ytickformat('')
    .ymin(0)
    .ymax(1)
    .height(12)
    .margins({top: 2, bottom: 30})
    .draw()
    .updateDateTimeAxis();

   pe = plot_element_sdomovie("#videocontainer")
    .subplot(sp)
    .loadData(); 
*/

</script>
